"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getJsPrinter = exports.getOriginalPrinter = exports.setOriginalPrinter = exports.getAndSetJsPlugin = exports.isJsPlugin = exports.jsPlugin = void 0;
function isJsPlugin(jsPlugin) {
    if (!jsPlugin) {
        return false;
    }
    if (typeof jsPlugin === 'string') {
        return false;
    }
    if (!jsPlugin.printers) {
        return false;
    }
    if (!jsPlugin.printers.estree) {
        return false;
    }
    return true;
}
exports.isJsPlugin = isJsPlugin;
function getAndSetJsPlugin(options) {
    if (!exports.jsPlugin) {
        const findPlugin = options.plugins.find((plugin) => typeof plugin !== 'string' && plugin.printers && plugin.printers.estree);
        if (!isJsPlugin(findPlugin)) {
            throw new Error(`Could not find default JS plugin.`);
        }
        exports.jsPlugin = findPlugin;
    }
    return exports.jsPlugin;
}
exports.getAndSetJsPlugin = getAndSetJsPlugin;
let originalPrinter;
function setOriginalPrinter(input) {
    originalPrinter = input;
}
exports.setOriginalPrinter = setOriginalPrinter;
function getOriginalPrinter() {
    if (!originalPrinter) {
        throw new Error(`originalPrinter hasn't been defined yet!`);
    }
    return originalPrinter;
}
exports.getOriginalPrinter = getOriginalPrinter;
function findOptionsArgument(input) {
    const props = [
        'semi',
        'singleQuote',
        'tabWidth',
    ];
    return input.find((entry) => {
        return props.every((prop) => entry.hasOwnProperty(prop));
    });
}
function getJsPrinter(args) {
    return getOriginalPrinter();
    // if (!jsPlugin) {
    //     const options = findOptionsArgument(args);
    //     if (options) {
    //         getAndSetJsPlugin(options);
    //     } else {
    //         throw new Error(`Could not find options argument.`);
    //     }
    // }
    // if (jsPlugin) {
    //     return jsPlugin.printers.estree;
    // } else {
    //     throw new Error('could not find js plugin for making a printer call');
    // }
}
exports.getJsPrinter = getJsPrinter;
